CREATE OR REPLACE FUNCTION bild_trigger() RETURNS trigger AS $$
die "Function is only usable in table bild" if($_TD->{relname} ne "bild");
use Image::Magick;
my $rv=spi_exec_query("select value as v from sysconfig where key in ('DOC_PFAD','MAX_IMAGE_SIZE') order by key");
my $DOC_PFAD=$rv->{rows}[0]->{v};
my $max_size=int($rv->{rows}[1]->{v});
die("no such directory $DOC_PFAD") if(! -d $DOC_PFAD);
my $pfad="$DOC_PFAD/image";
my $image = Image::Magick->new;

my $scale=0;
my $unlink=0;

if(! -d $pfad.'/intern'){ 
  mkdir($pfad.'/intern');
  system("cp '$DOC_PFAD/inc/.htaccess' '$pfad/intern/'"); 
  system("chmod -R go+rX '$pfad/intern'");  
}

if($_TD->{new}{name} && $_TD->{new}{name}=~ /\//){
	my $subfolder = $_TD->{new}{name};
	$subfolder=~ s|[^/]*$||;
	die("mkdir $pfad/$subfolder failed") if (system( "mkdir -p -m 0755 '$pfad/$subfolder'"));
	die("mkdir $pfad/t$subfolder failed") if (system( "mkdir -p -m 0755 '$pfad/t$subfolder'"));
	die("mkdir $pfad/o$subfolder failed") if (system( "mkdir -p -m 0755 '$pfad/o$subfolder'"));
	die("mkdir $pfad/intern/$subfolder failed") if (system( "mkdir -p -m 0755 '$pfad/intern/$subfolder'"));
	die("mkdir $pfad/intern/t$subfolder failed") if (system( "mkdir -p -m 0755 '$pfad/intern/t$subfolder'"));
	die("mkdir $pfad/intern/o$subfolder failed") if (system( "mkdir -p -m 0755 '$pfad/intern/o$subfolder'"));
}

# Getting source:
if($_TD->{new}{quelle} && -r $_TD->{new}{quelle}){
  $quelle=$_TD->{new}{quelle};
  if($_TD->{old}{name} && (($_TD->{old}{name} ne $_TD->{new}{name})
  || ($_TD->{old}{intern} ne $_TD->{new}{intern})) ){
    $unlink=1;
  } 
  $scale=1;
} else {
  $quelle="$pfad/".($_TD->{old}{intern} eq 't'?'intern/':'')."o".$_TD->{old}{name};
  if($_TD->{old}{height}!=$_TD->{new}{height} || 
     $_TD->{old}{theight}!=$_TD->{new}{theight} || 
     $_TD->{old}{intern} ne $_TD->{new}{intern} ){
    $scale=1;
  }
}
if($scale){
  $pfad="$DOC_PFAD/image".($_TD->{new}{intern} eq 't'?'/intern':'');
  my $res = $image->Read($quelle);
  die "$res" if "$res";
  my ($x,$y)=$image->Get('width','height');
  if($x>$max_size or $y>$max_size){
    if($x>$y){
      $factor=$x/$max_size;
    } else {
      $factor=$y/$max_size;
    }
    $image->Resize('width'=>int($x/$factor),'height'=>int($y/$factor));
  }
  $res = $image->Write(filename=>"$pfad/o".$_TD->{new}{name});
  die "$res" if "$res";
  chmod 0644,"$pfad/o".$_TD->{new}{name};
  ($x,$y)=$image->Get('width','height');
  $_TD->{new}{ox}=$x;
  $_TD->{new}{oy}=$y;
  my $faktor;
  if($_TD->{new}{height}){
    if($x>$y){
      $factor=$x/$_TD->{new}{height};
    } else {
      $factor=$y/$_TD->{new}{height};
    }
    $factor=1 if($factor<1);
    $image->Resize('width'=>int($x/$factor),'height'=>int($y/$factor));
    
  }
  $res = $image->Write(filename=>"$pfad/".$_TD->{new}{name});
  die "$res" if "$res";
  chmod 0644,"$pfad/".$_TD->{new}{name};
  ($x,$y)=$image->Get('width','height');
  $_TD->{new}{x}=$x;
  $_TD->{new}{y}=$y;
  print "$x-$y\n";

  if($_TD->{new}{theight}){
    if($x>$y){
      $factor=$x/$_TD->{new}{theight};
    } else {
      $factor=$y/$_TD->{new}{theight};
    }
    $factor=1 if($factor<1);
    $image->Resize('width'=>int($x/$factor),'height'=>int($y/$factor));
    
  }
  $res = $image->Write(filename=>"$pfad/t".$_TD->{new}{name});
  die "$res" if "$res";
  chmod 0644,"$pfad/t".$_TD->{new}{name};
  ($x,$y)=$image->Get('width','height');
  $_TD->{new}{tx}=$x;
  $_TD->{new}{ty}=$y;

  if($unlink){
    my $name=$_TD->{old}{name};
    $pfad="$DOC_PFAD/image".($_TD->{old}{intern} eq 't'?'/intern':'');
    unlink "$pfad/o$name" if( -f "$pfad/o$name");
    unlink "$pfad/t$name" if( -f "$pfad/t$name");
    if( -f "$pfad/$name"){
      unlink "$pfad/$name" or die ("Could not delete file $pfad/$name");
    }
  }  
  return "MODIFY"; 
} else {
  return;
}
$$ language plperlu;

DROP FUNCTION IF EXISTS public.htmldecode_de(text);
DROP FUNCTION IF EXISTS public.htmlencode_de(text);
DROP FUNCTION IF EXISTS public.change_user(integer, integer, character varying, character varying, character varying, character varying, integer);



